## [4.1.0]

* Support "greater" blocks with arbitrary names such as `#+begin_foo`
* Add initial support for dumping AST back to Org markup: `OrgNode.toMarkup`

## [4.0.0]

* Update to petitparser 6.0.1
* Require Dart 3.0 or higher

## [3.1.1]

* Fix parsing of section title text in some cases
  ([#13](https://github.com/amake/org_parser/issues/13))

## [3.1.0]

* Update to petitparser 5.4.0

## [3.0.0]

* Require petitparser 5.1.0 or higher
* Require Dart 2.18 or higher

## [2.2.1]

* Add dartdoc comments to AST, grammar, and parser objects
* Fix incorrect parsing of star-only headlines
  ([#5](https://github.com/amake/org_parser/issues/5))

## [2.2.0]

* Add utilities for recognizing, parsing `id:` and `#custom-id` URLs
  * `isOrgIdUrl` & `parseOrgIdUrl`
  * `isOrgCustomIdUrl` & `parseOrgCustomIdUrl`
* Add `OrgDrawer.properties` for obtaining drawer properties
* Add methods for getting the `ID` and `CUSTOM_ID` properties of a section
  * `OrgSection.ids`
  * `OrgSection.customIds`
* Add `OrgTree.visitSections` for efficiently walking just sections
* `OrgFileLink` now correctly recognizes links with empty file parts like
  `file:::*Section name`, which point to local sections; see
  `OrgFileLink.isLocal`.

## [2.1.1]
* Require petitparser 4.1.0 or higher

## [2.1.0]
* Relicense under the MIT License
* "Plain" links of all built-in types are now recognized (not just http(s): and
  mailto:)
* Added parser, AST for file links; see `OrgFileLink` class, `orgFileLink`
  variable
* Removed the following classes; use noted replacements
  * `OrgGrammar` → `OrgGrammarDefinition().build()`
  * `OrgContentGrammar` → `OrgContentGrammarDefinition().build()`
  * `OrgParser` → `org` variable
  * `OrgContentParser` → `OrgContentParserDefinition().build()`

## [2.0.0]

* Change class hierarchy of AST classes
  * All classes now inherit from `OrgNode`
  * All `OrgNode`s have a `children` property
  * `OrgTree.children` (sections only) is now `OrgTree.sections`
* Easily walk an AST with `OrgNode.visit`

## [1.0.1]

* Fix nullability errors in headline, src block

## [1.0.0]

* Migrate to non-nullable by default

## [0.5.0] - 2021-12-16

* Fix parsing of non-property drawer content
* Parse planning/clock lines as separate elements
  ([#2](https://github.com/amake/org_parser/issues/2))

## [0.4.1] - 2020-08-29

* Fix inline style markup (`*foo*`, `+bar+`, etc.) to span at most one line
  break

## [0.4.0] - 2020-07-21

* Parse entities (`\frac12` → ½, etc.)

## [0.3.2] - 2020-07-18

* More accurate tag handling in section headlines

## [0.3.1] - 2020-07-18

* Fix section headline parsing error

## [0.3.0] - 2020-07-14

* Parse inline and block LaTeX fragments
  ([#1](https://github.com/amake/org_parser/issues/1))

## [0.2.0] - 2020-06-20

* Parse src blocks (`#+begin_src`) as `OrgSrcBlock`; language of block is
  exposed as `OrgSrcBlock.language`

## [0.1.1+1] - 2020-05-21

* Add example

## [0.1.1] - 2020-05-06

* Added `OrgTable.columnIsNumeric` API for determining if a table column is
  primarily comprised of numbers

## [0.1.0] - 2020-05-05

* Initial release
